/* Sistemas Integrados TEKNISA
  Documentos Fiscais - Parametrizacao

Nome: 0001_GRSSTP0.SQL

@C:\web_565\sql\end_conv\oracle\clientes\grs\0001_GRSSTPO_USR_PREENCHE_TABELAS_FISCAIS.sql

Descrio:
Rotina para preenchimento das tabelas fiscais a partir do sistema Fiscal (GR SA).

PARA DEBUGAR
raise_application_error(-20501, '' , True);

Criao:
19/10/2010 - Fabrcio Marcelo da Silva
*/


CREATE OR REPLACE PROCEDURE USR_PREENCHE_TABELAS_FISCAIS
AS
   V_IDTRATIMPO     VARCHAR2(01);
   V_NRINCIDENCIA   VARCHAR2(20);
   V_NRALIQUOTA     VARCHAR2(20);
   V_NRINCCST       VARCHAR2(20);
   V_NRINCIDCFOP    VARCHAR2(20);

   V_NRINCIDCST     VARCHAR2(10);

   V_NRCONTADOR     INT;

   V_CDTPFATURFIS   VARCHAR2(05);
   V_CDGRUPOFISC    VARCHAR2(03);
BEGIN
   V_IDTRATIMPO   := '';
   V_NRINCIDENCIA := '';
   V_NRALIQUOTA   := '';
   V_NRINCCST     := '';
   V_NRINCIDCFOP  := '';

   V_NRINCIDCST   := '';

   V_CDTPFATURFIS := '';
   V_CDGRUPOFISC  := '';


   -- EXCLUI / INCLUI NOVAS FILIAIS CADASTRADAS PARA OS TIPOS DE CONTRATO --

   FOR NFIL IN
      (SELECT T.TP_CR, F.CDFILIAL, T.CD_OPER
         FROM USR_SAP_CR_TEC T, FILIAL F
        WHERE T.CD_EMP = 8
          AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL
          AND NOT T.CD_OPER IS NULL)
   LOOP
      DELETE FROM FILTPFATURFIS
       WHERE CDFILIAL = NFIL.CDFILIAL;

      IF (NFIL.CD_OPER <> '3') THEN

         V_CDTPFATURFIS := '';

         IF NFIL.TP_CR = 'G' THEN
            V_CDTPFATURFIS := '00001';
         ELSIF NFIL.TP_CR = 'M' THEN
            V_CDTPFATURFIS := '00002';
         ELSIF NFIL.TP_CR = 'R' THEN
            V_CDTPFATURFIS := '00003';
         ELSIF NFIL.TP_CR = 'O' THEN
            V_CDTPFATURFIS := '00003';
         ELSIF NFIL.TP_CR = 'V' THEN
            V_CDTPFATURFIS := '00003';
         ELSIF NFIL.TP_CR = 'A' THEN
            V_CDTPFATURFIS := '00004';
         ELSIF NFIL.TP_CR = 'F' THEN
            V_CDTPFATURFIS := '00005';
         ELSIF NFIL.TP_CR = 'T' THEN
            V_CDTPFATURFIS := '00006';
         END IF;

         IF NOT V_CDTPFATURFIS IS NULL THEN
            UPDATE FILTPFATURFIS
               SET DTULTATU = SYSDATE
             WHERE CDTPFATURFIS = V_CDTPFATURFIS
               AND CDFILIAL     = NFIL.CDFILIAL;

            IF SQL%ROWCOUNT = 0 THEN
               INSERT INTO FILTPFATURFIS
                  (CDTPFATURFIS, CDFILIAL, DTULTATU)
               VALUES
                  (V_CDTPFATURFIS, NFIL.CDFILIAL, SYSDATE);
            END IF;
         END IF;
      END IF;
   END LOOP;

   COMMIT;


   SELECT MAX(IDTRATIMPO)
     INTO V_IDTRATIMPO
     FROM IMPOSTO
    WHERE CDIMPOSTO = '00';


   -- INCIDENCIA P/ IMPOSTO ICMS ENTRADA --

   V_NRCONTADOR := 0;

   FOR C_INC IN
      (SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_INC.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_INC.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_INC.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_INC.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_INC.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_INC.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                         from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                        where t.st_indic_es_tipo_docto = 'E'

                          and t.st_oper_tipo_docto = C_INC.ST_OPER_RF

                          and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                          and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                          AND NOT DP.cd_tipo_docto_tec IS NULL
                          AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                          AND O.IDENTRSAIDOP = 'E')
      LOOP
         IF C_INC.CD_OPER = '3' THEN
            DELETE FROM INCIDENCIA
             WHERE CDPRODUTO = C_INC.CDPRODUTO
               AND CDEMPRESA = C_INC.CDEMPRESA
               AND CDINSCESTA = C_INC.CDINSCESTA
               AND IDENTRSAIDOP = C_INC.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDIMPOSTO = C_INC.CDIMPOSTO
               AND IDENTRSAIDIN = C_INC.IDENTRSAIDOP
               AND CDGRUPOFISC = V_CDGRUPOFISC;
         ELSE
            UPDATE INCIDENCIA
               SET CDFISCAL = C_INC.CODFISCAL,
                   DTULTATUINCI = SYSDATE
             WHERE CDPRODUTO = C_INC.CDPRODUTO
               AND CDEMPRESA = C_INC.CDEMPRESA
               AND CDINSCESTA = C_INC.CDINSCESTA
               AND IDENTRSAIDOP = C_INC.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDIMPOSTO = C_INC.CDIMPOSTO
               AND IDENTRSAIDIN = C_INC.IDENTRSAIDOP
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            IF SQL%ROWCOUNT = 0 THEN

               NOVO_CODIGO('INCIDENCIA', V_NRINCIDENCIA);
               V_NRINCIDENCIA := SUBSTR(V_NRINCIDENCIA,11,10);

               INSERT INTO INCIDENCIA
                  (NRINCIDENCIA, CDPRODUTO, CDEMPRESA, CDINSCESTA, IDENTRSAIDOP,
                   CDTIPOOPER, CDIMPOSTO, IDENTRSAIDIN, IDTRATIMPOIN, CDFISCAL,
                   CDGRUPOFISC, IDINCINTEREST, DTULTATUINCI)
               VALUES
                  (V_NRINCIDENCIA, C_INC.CDPRODUTO, C_INC.CDEMPRESA, C_INC.CDINSCESTA, C_INC.IDENTRSAIDOP,
                   C_TPOPER.CDTIPOOPER, C_INC.CDIMPOSTO, C_INC.IDENTRSAIDOP, V_IDTRATIMPO, C_INC.CODFISCAL,
                   V_CDGRUPOFISC, C_INC.IDINTEREST, SYSDATE);
            END IF;
         END IF;

         V_NRCONTADOR := V_NRCONTADOR + 1;

         IF V_NRCONTADOR = 500 THEN
            V_NRCONTADOR := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   COMMIT;

   -- INCIDENCIA P/ IMPOSTO ICMS SAIDA --

   V_NRCONTADOR := 0;

   FOR C_INC IN
      (SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'N' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
       UNION
       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER, TO_CHAR(MIN(C.CD_INDIC_TRBUT_CLASS_FISC)) AS CODFISCAL, 'S' IDINTEREST
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_INC.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_INC.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_INC.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_INC.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_INC.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_INC.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                         from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                        where t.st_indic_es_tipo_docto = 'S'

                          and t.st_oper_tipo_docto = C_INC.ST_OPER_RF

                          and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                          and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                          AND NOT DP.cd_tipo_docto_tec IS NULL
                          AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                          AND O.IDENTRSAIDOP = 'S'
                          AND O.CDTIPOOPER NOT IN ('01','24','03','47','13','12'))
      LOOP
         IF C_INC.CD_OPER = '3' THEN
            DELETE FROM INCIDENCIA
             WHERE CDPRODUTO = C_INC.CDPRODUTO
               AND CDEMPRESA = C_INC.CDEMPRESA
               AND CDINSCESTA = C_INC.CDINSCESTA
               AND IDENTRSAIDOP = C_INC.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDIMPOSTO = C_INC.CDIMPOSTO
               AND IDENTRSAIDIN = C_INC.IDENTRSAIDOP
               AND CDGRUPOFISC = V_CDGRUPOFISC;
         ELSE
            UPDATE INCIDENCIA
               SET CDFISCAL = C_INC.CODFISCAL,
                   DTULTATUINCI = SYSDATE
             WHERE CDPRODUTO = C_INC.CDPRODUTO
               AND CDEMPRESA = C_INC.CDEMPRESA
               AND CDINSCESTA = C_INC.CDINSCESTA
               AND IDENTRSAIDOP = C_INC.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDIMPOSTO = C_INC.CDIMPOSTO
               AND IDENTRSAIDIN = C_INC.IDENTRSAIDOP
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            IF SQL%ROWCOUNT = 0 THEN

               NOVO_CODIGO('INCIDENCIA', V_NRINCIDENCIA);
               V_NRINCIDENCIA := SUBSTR(V_NRINCIDENCIA,11,10);

               INSERT INTO INCIDENCIA
                  (NRINCIDENCIA, CDPRODUTO, CDEMPRESA, CDINSCESTA, IDENTRSAIDOP,
                   CDTIPOOPER, CDIMPOSTO, IDENTRSAIDIN, IDTRATIMPOIN, CDFISCAL,
                   CDGRUPOFISC, IDINCINTEREST, DTULTATUINCI)
               VALUES
                  (V_NRINCIDENCIA, C_INC.CDPRODUTO, C_INC.CDEMPRESA, C_INC.CDINSCESTA, C_INC.IDENTRSAIDOP,
                   C_TPOPER.CDTIPOOPER, C_INC.CDIMPOSTO, C_INC.IDENTRSAIDOP, V_IDTRATIMPO, C_INC.CODFISCAL,
                   V_CDGRUPOFISC, C_INC.IDINTEREST, SYSDATE);
            END IF;
         END IF;

         V_NRCONTADOR := V_NRCONTADOR + 1;

         IF V_NRCONTADOR = 500 THEN
            V_NRCONTADOR := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   COMMIT;


   -- ALIQUOTA P/ IMPOSTO ICMS ENTRADA --

   V_NRCONTADOR := 0;

   FOR C_ALI IN
      (SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_GEST_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_MANDT_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_REVEN_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ADM_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_FAC_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ACT_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_ALI.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_ALI.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_ALI.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_ALI.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_ALI.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_ALI.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      IF C_ALI.CD_OPER = '3' THEN
         DELETE FROM ALIQUOTA
          WHERE CDIMPOSTO = C_ALI.CDIMPOSTO
            AND CDEMPRESA = C_ALI.CDEMPRESA
            AND IDENTRSAIDAL = C_ALI.IDENTRSAIDOP
            AND CDINSCESTA = C_ALI.CDINSCESTA
            AND CDPRODUTO = C_ALI.CDPRODUTO
            AND CDPAISORIG = '0055'
            AND SGESTAORIG = C_ALI.CD_UF_ORIG
            AND CDPAISDEST = '0055'
            AND SGESTADEST = C_ALI.CD_UF_DEST
            AND CDGRUPOFISC = V_CDGRUPOFISC;
      ELSE
         UPDATE ALIQUOTA
            SET VRPERREDBC = C_ALI.VRPERREDBC,
                VRALIQUOTA = C_ALI.TX_ALIQ_ICMS_CLASS_FISC,
                DTULTATUALIQ = SYSDATE
          WHERE CDIMPOSTO = C_ALI.CDIMPOSTO
            AND CDEMPRESA = C_ALI.CDEMPRESA
            AND IDENTRSAIDAL = C_ALI.IDENTRSAIDOP
            AND CDINSCESTA = C_ALI.CDINSCESTA
            AND CDPRODUTO = C_ALI.CDPRODUTO
            AND CDPAISORIG = '0055'
            AND SGESTAORIG = C_ALI.CD_UF_ORIG
            AND CDPAISDEST = '0055'
            AND SGESTADEST = C_ALI.CD_UF_DEST
            AND CDGRUPOFISC = V_CDGRUPOFISC;

         IF SQL%ROWCOUNT = 0 THEN

            NOVO_CODIGO('ALIQUOTA', V_NRALIQUOTA);
            V_NRALIQUOTA := SUBSTR(V_NRALIQUOTA,11,10);

            INSERT INTO ALIQUOTA
               (NRALIQUOTA, CDIMPOSTO, CDEMPRESA, IDENTRSAIDAL, CDINSCESTA, CDPRODUTO,
                CDPAISORIG, SGESTAORIG, CDMUNIORIG, CDPAISDEST, SGESTADEST, DTINIVALID,
                VRINIFAIXA, VRFIMFAIXA, VRPARDEDUZ, VRPERREDBC, VRALIQUOTA, CDGRUPOFISC,
                VRPBCSUBTRIB, IDTRATIMPST, IDPMCBASECAL, IDENTRSAIDOP, CDTIPOOPER, DTULTATUALIQ)
            VALUES
               (V_NRALIQUOTA, C_ALI.CDIMPOSTO, C_ALI.CDEMPRESA, C_ALI.IDENTRSAIDOP, C_ALI.CDINSCESTA, C_ALI.CDPRODUTO,
                '0055', C_ALI.CD_UF_ORIG, NULL, '0055', C_ALI.CD_UF_DEST, TO_DATE('01/' || TO_CHAR(SYSDATE, 'MM/YYYY')),
                0, 0, 0, C_ALI.VRPERREDBC, C_ALI.TX_ALIQ_ICMS_CLASS_FISC, V_CDGRUPOFISC,
                0, NULL, 'S', NULL, NULL, SYSDATE);
         END IF;
      END IF;

      V_NRCONTADOR := V_NRCONTADOR + 1;

      IF V_NRCONTADOR = 500 THEN
         V_NRCONTADOR := 0;
         COMMIT;
      END IF;
   END LOOP;

   COMMIT;

   -- ALIQUOTA P/ IMPOSTO ICMS SAIDA --

   V_NRCONTADOR := 0;

   FOR C_ALI IN
      (SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_GEST_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_MANDT_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_REVEN_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ADM_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_FAC_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC

        UNION

        SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, UPPER(CD_UF_ORIG) AS CD_UF_ORIG, UPPER(CD_UF_DEST) AS CD_UF_DEST,
              R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)) AS VRPERREDBC, TX_ALIQ_ICMS_CLASS_FISC
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ACT_RF = C.CD_CLASS_FISC
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, UPPER(CD_UF_ORIG), UPPER(CD_UF_DEST),
                 R.CD_OPER, F.TP_CR, R.ST_OPER_RF, DECODE(TX_REDUZ_BASE_ICMS_CLASS_FISC, 0, 0, ROUND(100 - TX_REDUZ_BASE_ICMS_CLASS_FISC, 2)), TX_ALIQ_ICMS_CLASS_FISC
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_ALI.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_ALI.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_ALI.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_ALI.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_ALI.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_ALI.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                         from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                        where t.st_indic_es_tipo_docto = 'S'

                          and t.st_oper_tipo_docto = C_ALI.ST_OPER_RF

                          and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                          and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                          AND NOT DP.cd_tipo_docto_tec IS NULL
                          AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                          AND O.IDENTRSAIDOP = 'S'
                          AND O.CDTIPOOPER NOT IN ('01','24','03','47','13','12'))
      LOOP
         IF C_ALI.CD_OPER = '3' THEN
            DELETE FROM ALIQUOTA
             WHERE CDIMPOSTO = C_ALI.CDIMPOSTO
               AND CDEMPRESA = C_ALI.CDEMPRESA
               AND IDENTRSAIDAL = C_ALI.IDENTRSAIDOP
               AND CDINSCESTA = C_ALI.CDINSCESTA
               AND CDPRODUTO = C_ALI.CDPRODUTO
               AND CDPAISORIG = '0055'
               AND SGESTAORIG = C_ALI.CD_UF_ORIG
               AND CDPAISDEST = '0055'
               AND SGESTADEST = C_ALI.CD_UF_DEST
               AND CDGRUPOFISC = V_CDGRUPOFISC
               AND IDENTRSAIDOP = C_ALI.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER;
         ELSE
            UPDATE ALIQUOTA
               SET VRPERREDBC = C_ALI.VRPERREDBC,
                   VRALIQUOTA = C_ALI.TX_ALIQ_ICMS_CLASS_FISC,
                   DTULTATUALIQ = SYSDATE
             WHERE CDIMPOSTO = C_ALI.CDIMPOSTO
               AND CDEMPRESA = C_ALI.CDEMPRESA
               AND IDENTRSAIDAL = C_ALI.IDENTRSAIDOP
               AND CDINSCESTA = C_ALI.CDINSCESTA
               AND CDPRODUTO = C_ALI.CDPRODUTO
               AND CDPAISORIG = '0055'
               AND SGESTAORIG = C_ALI.CD_UF_ORIG
               AND CDPAISDEST = '0055'
               AND SGESTADEST = C_ALI.CD_UF_DEST
               AND CDGRUPOFISC = V_CDGRUPOFISC
               AND IDENTRSAIDOP = C_ALI.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER;

            IF SQL%ROWCOUNT = 0 THEN

               NOVO_CODIGO('ALIQUOTA', V_NRALIQUOTA);
               V_NRALIQUOTA := SUBSTR(V_NRALIQUOTA,11,10);

               INSERT INTO ALIQUOTA
                  (NRALIQUOTA, CDIMPOSTO, CDEMPRESA, IDENTRSAIDAL, CDINSCESTA, CDPRODUTO,
                   CDPAISORIG, SGESTAORIG, CDMUNIORIG, CDPAISDEST, SGESTADEST, DTINIVALID,
                   VRINIFAIXA, VRFIMFAIXA, VRPARDEDUZ, VRPERREDBC, VRALIQUOTA, CDGRUPOFISC,
                   VRPBCSUBTRIB, IDTRATIMPST, IDPMCBASECAL, IDENTRSAIDOP, CDTIPOOPER, DTULTATUALIQ)
               VALUES
                  (V_NRALIQUOTA, C_ALI.CDIMPOSTO, C_ALI.CDEMPRESA, C_ALI.IDENTRSAIDOP, C_ALI.CDINSCESTA, C_ALI.CDPRODUTO,
                   '0055', C_ALI.CD_UF_ORIG, NULL, '0055', C_ALI.CD_UF_DEST, TO_DATE('01/' || TO_CHAR(SYSDATE, 'MM/YYYY')),
                   0, 0, 0, C_ALI.VRPERREDBC, C_ALI.TX_ALIQ_ICMS_CLASS_FISC, V_CDGRUPOFISC,
                   0, NULL, 'S', C_ALI.IDENTRSAIDOP, C_TPOPER.CDTIPOOPER, SYSDATE);
            END IF;
         END IF;

         V_NRCONTADOR := V_NRCONTADOR + 1;

         IF V_NRCONTADOR = 500 THEN
            V_NRCONTADOR := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   COMMIT;


   -- CST P/ IMPOSTO ICMS ENTRADA --

   V_NRCONTADOR := 0;

   FOR C_CST IN
      (SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_ENT_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'E',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_CST.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_CST.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_CST.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_CST.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_CST.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_CST.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                         from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                        where t.st_indic_es_tipo_docto = 'E'

                          and t.st_oper_tipo_docto = C_CST.ST_OPER_RF

                          and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                          and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                          AND NOT DP.cd_tipo_docto_tec IS NULL
                          AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                          AND O.IDENTRSAIDOP = 'E')
      LOOP
         IF C_CST.CD_OPER = '3' THEN
            SELECT MAX(NRINCIDCST)
              INTO V_NRINCIDCST
              FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND IDCSTINTEREST = C_CST.IDINTEREST
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            DELETE FROM CODSITUTRIBNFE
             WHERE NRINCIDCST = V_NRINCIDCST;

            DELETE FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND CDGRUPOFISC = V_CDGRUPOFISC;
         ELSE
            UPDATE CODSITUTRIB
               SET CDSITUTRIB = C_CST.CD_TRIB_ICMS,
                   DTULTATUCSTR = SYSDATE
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            SELECT MAX(NRINCIDCST)
              INTO V_NRINCIDCST
              FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND IDCSTINTEREST = C_CST.IDINTEREST
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            UPDATE CODSITUTRIBNFE
               SET CDSITUTRIBNFE = C_CST.CD_TRIB_ICMS
            WHERE NRINCIDCST = V_NRINCIDCST;

            IF SQL%ROWCOUNT = 0 THEN

               NOVO_CODIGO('SITUTRIB', V_NRINCCST);
               V_NRINCCST := SUBSTR(V_NRINCCST,11,10);

               INSERT INTO CODSITUTRIB
                  (NRINCIDCST, IDENTSAICST, IDENTRSAIDOP, CDTIPOOPER, CDEMPRESA,
                   CDINSCESTA, CDPRODUTO, CDSITUTRIB, CDGRUPOFISC, IDCSTINTEREST, DTULTATUCSTR)
               VALUES
                  (V_NRINCCST, C_CST.IDENTRSAIDOP, C_CST.IDENTRSAIDOP, C_TPOPER.CDTIPOOPER, C_CST.CDEMPRESA,
                   C_CST.CDINSCESTA, C_CST.CDPRODUTO, C_CST.CD_TRIB_ICMS, V_CDGRUPOFISC, 'N', SYSDATE);

                INSERT INTO CODSITUTRIBNFE
                   (NRINCIDCST, CDIMPOSTO, CDSITUTRIBNFE, IDMODBCNFE, IDMODBCSTNFE)
                VALUES
                   (V_NRINCCST, C_CST.CDIMPOSTO, C_CST.CD_TRIB_ICMS, '3', '4');
            END IF;
         END IF;

         V_NRCONTADOR := V_NRCONTADOR + 1;

         IF V_NRCONTADOR = 500 THEN
            V_NRCONTADOR := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   COMMIT;

   -- CST P/ IMPOSTO ICMS SAIDA --

   V_NRCONTADOR := 0;

   FOR C_CST IN
      (SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'G'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_GEST_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'M'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_MANDT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'R'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_REVEN_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'A'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ADM_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'F'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_FAC_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF

       UNION

       SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'N' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) = UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'N', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        UNION
        SELECT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, 'S' IDINTEREST, R.CD_OPER, F.TP_CR, R.ST_OPER_RF, MIN(R.DT_OPER) AS DT_OPER,
              LPAD(TO_CHAR(MIN(CD_TRIB_ICMS)),2,'0') AS CD_TRIB_ICMS
         FROM USR_SAP_RF_TEC R, USR_SAP_CLASS_FISC_TEC C, INSCRESTAD I, PRODUTO P,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND T.TP_CR = 'T'
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F
        WHERE CD_TIPO_PROD = 1
          AND CD_PARAMETRO = 1
          AND R.CD_CLASS_FISC_SAI_ACT_RF = C.CD_CLASS_FISC
          AND UPPER(R.CD_UF_ORIG) <> UPPER(R.CD_UF_DEST)
          AND I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(R.CD_UF_DEST)
          AND P.CDARVPROD = R.CD_PROD
        GROUP BY '00', '08', I.CDINSCESTA, 'S',
                 P.CDPRODUTO, 'S', R.CD_OPER, F.TP_CR, R.ST_OPER_RF
        ORDER BY DT_OPER)
   LOOP
      V_CDGRUPOFISC := '';

      IF C_CST.TP_CR = 'G' THEN
         V_CDGRUPOFISC := '005';
      ELSIF C_CST.TP_CR = 'M' THEN
         V_CDGRUPOFISC := '006';
      ELSIF C_CST.TP_CR = 'R' THEN
         V_CDGRUPOFISC := '007';
      ELSIF C_CST.TP_CR = 'A' THEN
         V_CDGRUPOFISC := '008';
      ELSIF C_CST.TP_CR = 'F' THEN
         V_CDGRUPOFISC := '009';
      ELSIF C_CST.TP_CR = 'T' THEN
         V_CDGRUPOFISC := '010';
      END IF;

      FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                         from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                        where t.st_indic_es_tipo_docto = 'S'

                          and t.st_oper_tipo_docto = C_CST.ST_OPER_RF

                          and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                          and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                          AND NOT DP.cd_tipo_docto_tec IS NULL
                          AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                          AND O.IDENTRSAIDOP = 'S'
                          AND O.CDTIPOOPER NOT IN ('01','24','03','47','13','12'))
      LOOP
         IF C_CST.CD_OPER = '3' THEN
            SELECT MAX(NRINCIDCST)
              INTO V_NRINCIDCST
              FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND IDCSTINTEREST = C_CST.IDINTEREST
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            DELETE FROM CODSITUTRIBNFE
             WHERE NRINCIDCST = V_NRINCIDCST;

            DELETE FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND CDGRUPOFISC = V_CDGRUPOFISC;
         ELSE
            UPDATE CODSITUTRIB
               SET CDSITUTRIB = C_CST.CD_TRIB_ICMS,
                   DTULTATUCSTR = SYSDATE
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            SELECT MAX(NRINCIDCST)
              INTO V_NRINCIDCST
              FROM CODSITUTRIB
             WHERE IDENTSAICST = C_CST.IDENTRSAIDOP
               AND IDENTRSAIDOP = C_CST.IDENTRSAIDOP
               AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
               AND CDEMPRESA = C_CST.CDEMPRESA
               AND CDINSCESTA = C_CST.CDINSCESTA
               AND CDPRODUTO = C_CST.CDPRODUTO
               AND IDCSTINTEREST = C_CST.IDINTEREST
               AND CDGRUPOFISC = V_CDGRUPOFISC;

            UPDATE CODSITUTRIBNFE
               SET CDSITUTRIBNFE = C_CST.CD_TRIB_ICMS
            WHERE NRINCIDCST = V_NRINCIDCST;

            IF SQL%ROWCOUNT = 0 THEN

               NOVO_CODIGO('SITUTRIB', V_NRINCCST);
               V_NRINCCST := SUBSTR(V_NRINCCST,11,10);

               INSERT INTO CODSITUTRIB
                  (NRINCIDCST, IDENTSAICST, IDENTRSAIDOP, CDTIPOOPER, CDEMPRESA,
                   CDINSCESTA, CDPRODUTO, CDSITUTRIB, CDGRUPOFISC, IDCSTINTEREST, DTULTATUCSTR)
               VALUES
                  (V_NRINCCST, C_CST.IDENTRSAIDOP, C_CST.IDENTRSAIDOP, C_TPOPER.CDTIPOOPER, C_CST.CDEMPRESA,
                   C_CST.CDINSCESTA, C_CST.CDPRODUTO, C_CST.CD_TRIB_ICMS, V_CDGRUPOFISC, 'N', SYSDATE);

                INSERT INTO CODSITUTRIBNFE
                   (NRINCIDCST, CDIMPOSTO, CDSITUTRIBNFE, IDMODBCNFE, IDMODBCSTNFE)
                VALUES
                   (V_NRINCCST, C_CST.CDIMPOSTO, C_CST.CD_TRIB_ICMS, '3', '4');
            END IF;
         END IF;

         V_NRCONTADOR := V_NRCONTADOR + 1;

         IF V_NRCONTADOR = 500 THEN
            V_NRCONTADOR := 0;
            COMMIT;
         END IF;
      END LOOP;
   END LOOP;

   COMMIT;


   -- CFOP ENTRADA --

   V_NRCONTADOR := 0;

   FOR C_CFO IN
      (SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, TO_DATE('01'||'/'||C.MES||'/'||C.ANO) AS DTINIVALID,
              C.CD_CFO, D.DS_CFO, 'N' IDINTEREST, C.DT_OPER, C.CD_OPER, F.TP_CR, C.ST_OPER
         FROM INSCRESTAD I, PRODUTO P,
              (SELECT CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER, MAX(T.DT_OPER) AS DT_OPER, MAX(DT_CTBIL_MM) AS MES, MAX(DT_CTBIL_AA) AS ANO, SUBSTR(TO_CHAR(MAX(CD_CFO)),2,3) AS CD_CFO
                 FROM USR_SAP_RCFO_TEC T
      	        WHERE CD_TIPO_PROD = 1
	          AND CD_TIPO_DOCTO = 1
                  AND ST_INDIC_ES = 'E'
                  AND UPPER(T.CD_UF_ORIG) = UPPER(T.CD_UF_DEST)
                GROUP BY CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER) C,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F,
              USR_SAP_CFO_TEC D
        WHERE I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(C.CD_UF_DEST)
          AND P.CDARVPROD = C.CD_PROD
          AND '1'||C.CD_CFO = D.CD_CFO
       UNION
       SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'E' AS IDENTRSAIDOP,
              P.CDPRODUTO, TO_DATE('01'||'/'||C.MES||'/'||C.ANO) AS DTINIVALID,
              C.CD_CFO, D.DS_CFO, 'S' IDINTEREST, C.DT_OPER, C.CD_OPER, F.TP_CR, C.ST_OPER
         FROM INSCRESTAD I, PRODUTO P,
              (SELECT CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER, MAX(T.DT_OPER) AS DT_OPER, MAX(DT_CTBIL_MM) AS MES, MAX(DT_CTBIL_AA) AS ANO, SUBSTR(TO_CHAR(MAX(CD_CFO)),2,3) AS CD_CFO
                 FROM USR_SAP_RCFO_TEC T
      	        WHERE CD_TIPO_PROD = 1
	          AND CD_TIPO_DOCTO = 1
                  AND ST_INDIC_ES = 'E'
                  AND UPPER(T.CD_UF_ORIG) <> UPPER(T.CD_UF_DEST)
                GROUP BY CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER) C,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F,
              USR_SAP_CFO_TEC D
        WHERE I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(C.CD_UF_DEST)
          AND P.CDARVPROD = C.CD_PROD
          AND '2'||C.CD_CFO = D.CD_CFO
        ORDER BY DT_OPER)
   LOOP
      IF C_CFO.TP_CR <> 'O' AND C_CFO.TP_CR <> 'V' THEN

         V_CDGRUPOFISC := '';

         IF C_CFO.TP_CR = 'G' THEN
            V_CDGRUPOFISC := '005';
         ELSIF C_CFO.TP_CR = 'M' THEN
            V_CDGRUPOFISC := '006';
         ELSIF C_CFO.TP_CR = 'R' THEN
            V_CDGRUPOFISC := '007';
         ELSIF C_CFO.TP_CR = 'A' THEN
            V_CDGRUPOFISC := '008';
         ELSIF C_CFO.TP_CR = 'F' THEN
            V_CDGRUPOFISC := '009';
         ELSIF C_CFO.TP_CR = 'T' THEN
            V_CDGRUPOFISC := '010';
         END IF;

         FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                            from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                           where t.st_indic_es_tipo_docto = 'E'

                             and t.st_oper_tipo_docto = C_CFO.ST_OPER

                             and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                             and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                             AND NOT DP.cd_tipo_docto_tec IS NULL
                             AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                             AND O.IDENTRSAIDOP = 'E')

         LOOP
            IF C_CFO.CD_OPER = '3' THEN
               DELETE FROM CODFISCOPER
                WHERE CDEMPRESA = C_CFO.CDEMPRESA
                  AND IDENTRSAIDOP = C_CFO.IDENTRSAIDOP
                  AND IDENTSAICFOP = C_CFO.IDENTRSAIDOP
                  AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
                  AND CDINSCESTA = C_CFO.CDINSCESTA
                  AND CDPRODUTO  = C_CFO.CDPRODUTO
                  AND CDGRUPOFISC = V_CDGRUPOFISC
                  AND DTVALIDCFOP = C_CFO.DTINIVALID
				  AND IDCFOPINTEREST = C_CFO.IDINTEREST;
            ELSE
               UPDATE CODFISCOPER
                  SET CDFISCOPER = C_CFO.CD_CFO,
                      DSCDFISCOPER = C_CFO.DS_CFO,
                      DTULTATUCFOP = SYSDATE
                WHERE CDEMPRESA = C_CFO.CDEMPRESA
                  AND IDENTRSAIDOP = C_CFO.IDENTRSAIDOP
                  AND IDENTSAICFOP = C_CFO.IDENTRSAIDOP
                  AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
                  AND CDINSCESTA = C_CFO.CDINSCESTA
                  AND CDPRODUTO  = C_CFO.CDPRODUTO
                  AND CDGRUPOFISC = V_CDGRUPOFISC
                  AND DTVALIDCFOP = C_CFO.DTINIVALID
				  AND IDCFOPINTEREST = C_CFO.IDINTEREST;

               IF SQL%ROWCOUNT = 0 THEN

                  NOVO_CODIGO('FISCOPER', V_NRINCIDCFOP);
                  V_NRINCIDCFOP := SUBSTR(V_NRINCIDCFOP,11,10);

                  INSERT INTO CODFISCOPER
                     (NRINCIDCFOP, CDEMPRESA, IDENTRSAIDOP, IDENTSAICFOP,
                      CDTIPOOPER, CDINSCESTA, CDPRODUTO, CDFISCOPER,
                      DSCDFISCOPER, CDSUFXCFOP, CDGRUPOFISC, DTVALIDCFOP,
                      IDDIFEALIQ, CDMODDOCFISC, IDCFOPINTEREST, DTULTATUCFOP)
                  VALUES
                     (V_NRINCIDCFOP, C_CFO.CDEMPRESA, C_CFO.IDENTRSAIDOP, C_CFO.IDENTRSAIDOP,
                      C_TPOPER.CDTIPOOPER, C_CFO.CDINSCESTA, C_CFO.CDPRODUTO, C_CFO.CD_CFO,
                      C_CFO.DS_CFO, NULL, V_CDGRUPOFISC, C_CFO.DTINIVALID,
                      'N', NULL, C_CFO.IDINTEREST, SYSDATE);
               END IF;
            END IF;
            
            V_NRCONTADOR := V_NRCONTADOR + 1;

            IF V_NRCONTADOR = 500 THEN
               V_NRCONTADOR := 0;
               COMMIT;
            END IF;

         END LOOP;
      END IF;
   END LOOP;

   COMMIT;


   -- CFOP SAIDA --

   V_NRCONTADOR := 0;

   FOR C_CFO IN
      (SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, TO_DATE('01'||'/'||C.MES||'/'||C.ANO) AS DTINIVALID,
              C.CD_CFO, D.DS_CFO, 'N' IDINTEREST, C.DT_OPER, C.CD_OPER, F.TP_CR, C.ST_OPER
         FROM INSCRESTAD I, PRODUTO P,
              (SELECT CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER, MAX(T.DT_OPER) AS DT_OPER, MAX(DT_CTBIL_MM) AS MES, MAX(DT_CTBIL_AA) AS ANO, SUBSTR(TO_CHAR(MAX(CD_CFO)),2,3) AS CD_CFO
                 FROM USR_SAP_RCFO_TEC T
      	        WHERE CD_TIPO_PROD = 1
	          AND CD_TIPO_DOCTO = 1
                  AND ST_INDIC_ES = 'S'
                  AND UPPER(T.CD_UF_ORIG) = UPPER(T.CD_UF_DEST)
                GROUP BY CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER) C,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F,
              USR_SAP_CFO_TEC D
        WHERE I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(C.CD_UF_DEST)
          AND P.CDARVPROD = C.CD_PROD
          AND '1'||C.CD_CFO = D.CD_CFO
       UNION
       SELECT DISTINCT '00' AS CDIMPOSTO, '08' AS CDEMPRESA, I.CDINSCESTA, 'S' AS IDENTRSAIDOP,
              P.CDPRODUTO, TO_DATE('01'||'/'||C.MES||'/'||C.ANO) AS DTINIVALID,
              C.CD_CFO, D.DS_CFO, 'S' IDINTEREST, C.DT_OPER, C.CD_OPER, F.TP_CR, C.ST_OPER
         FROM INSCRESTAD I, PRODUTO P,
              (SELECT CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER, MAX(T.DT_OPER) AS DT_OPER, MAX(DT_CTBIL_MM) AS MES, MAX(DT_CTBIL_AA) AS ANO, SUBSTR(TO_CHAR(MAX(CD_CFO)),2,3) AS CD_CFO
                 FROM USR_SAP_RCFO_TEC T
      	        WHERE CD_TIPO_PROD = 1
	          AND CD_TIPO_DOCTO = 1
                  AND ST_INDIC_ES = 'S'
                  AND UPPER(T.CD_UF_ORIG) <> UPPER(T.CD_UF_DEST)
                GROUP BY CD_PROD, CD_UF_DEST, T.CD_OPER, T.ST_OPER) C,
              (SELECT DISTINCT T.TP_CR, F.CDINSCESTA
                 FROM USR_SAP_CR_TEC T, FILIAL F
                WHERE T.CD_EMP = 8
                  AND LPAD(T.CD_CR, 4, '0') = F.CDFILIAL) F,
              USR_SAP_CFO_TEC D
        WHERE I.CDEMPRESA = '08'
          AND I.CDINSCESTA = F.CDINSCESTA
          AND I.SGESTADO = UPPER(C.CD_UF_DEST)
          AND P.CDARVPROD = C.CD_PROD
          AND '2'||C.CD_CFO = D.CD_CFO
        ORDER BY DT_OPER)
   LOOP
      IF C_CFO.TP_CR <> 'O' AND C_CFO.TP_CR <> 'V' THEN

         V_CDGRUPOFISC := '';

         IF C_CFO.TP_CR = 'G' THEN
            V_CDGRUPOFISC := '005';
         ELSIF C_CFO.TP_CR = 'M' THEN
            V_CDGRUPOFISC := '006';
         ELSIF C_CFO.TP_CR = 'R' THEN
            V_CDGRUPOFISC := '007';
         ELSIF C_CFO.TP_CR = 'A' THEN
            V_CDGRUPOFISC := '008';
         ELSIF C_CFO.TP_CR = 'F' THEN
            V_CDGRUPOFISC := '009';
         ELSIF C_CFO.TP_CR = 'T' THEN
            V_CDGRUPOFISC := '010';
         END IF;

         FOR C_TPOPER IN (select DISTINCT O.CDTIPOOPER
                            from USR_SAP_TIPO_DOCTO_TEC t, USR_SAP_TIPO_DOCTO_DP_TEC dp, TIPOOPERAC O
                           where t.st_indic_es_tipo_docto = 'S'

                             and t.st_oper_tipo_docto = C_CFO.ST_OPER

                             and t.cd_tipo_digta_tipo_docto = dp.cd_tipo_dig_fisc
                             and t.cd_tipo_docto = dp.cd_tipo_docto_fisc
                             AND NOT DP.cd_tipo_docto_tec IS NULL
                             AND TRIM(DP.cd_tipo_docto_tec) = O.CDEXTIPOOPER

                             AND O.IDENTRSAIDOP = 'S'
                             AND O.CDTIPOOPER NOT IN ('01','24','03','47','13','12'))

         LOOP
            IF C_CFO.CD_OPER = '3' THEN
               DELETE FROM CODFISCOPER
                WHERE CDEMPRESA = C_CFO.CDEMPRESA
                  AND IDENTRSAIDOP = C_CFO.IDENTRSAIDOP
                  AND IDENTSAICFOP = C_CFO.IDENTRSAIDOP
                  AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
                  AND CDINSCESTA = C_CFO.CDINSCESTA
                  AND CDPRODUTO  = C_CFO.CDPRODUTO
                  AND CDGRUPOFISC = V_CDGRUPOFISC
                  AND DTVALIDCFOP = C_CFO.DTINIVALID
				  AND IDCFOPINTEREST = C_CFO.IDINTEREST;
            ELSE
               UPDATE CODFISCOPER
                  SET CDFISCOPER = C_CFO.CD_CFO,
                      DSCDFISCOPER = C_CFO.DS_CFO,
                      DTULTATUCFOP = SYSDATE
                WHERE CDEMPRESA = C_CFO.CDEMPRESA
                  AND IDENTRSAIDOP = C_CFO.IDENTRSAIDOP
                  AND IDENTSAICFOP = C_CFO.IDENTRSAIDOP
                  AND CDTIPOOPER = C_TPOPER.CDTIPOOPER
                  AND CDINSCESTA = C_CFO.CDINSCESTA
                  AND CDPRODUTO  = C_CFO.CDPRODUTO
                  AND CDGRUPOFISC = V_CDGRUPOFISC
                  AND DTVALIDCFOP = C_CFO.DTINIVALID
				  AND IDCFOPINTEREST = C_CFO.IDINTEREST;

               IF SQL%ROWCOUNT = 0 THEN

                  NOVO_CODIGO('FISCOPER', V_NRINCIDCFOP);
                  V_NRINCIDCFOP := SUBSTR(V_NRINCIDCFOP,11,10);

                  INSERT INTO CODFISCOPER
                     (NRINCIDCFOP, CDEMPRESA, IDENTRSAIDOP, IDENTSAICFOP,
                      CDTIPOOPER, CDINSCESTA, CDPRODUTO, CDFISCOPER,
                      DSCDFISCOPER, CDSUFXCFOP, CDGRUPOFISC, DTVALIDCFOP,
                      IDDIFEALIQ, CDMODDOCFISC, IDCFOPINTEREST, DTULTATUCFOP)
                  VALUES
                     (V_NRINCIDCFOP, C_CFO.CDEMPRESA, C_CFO.IDENTRSAIDOP, C_CFO.IDENTRSAIDOP,
                      C_TPOPER.CDTIPOOPER, C_CFO.CDINSCESTA, C_CFO.CDPRODUTO, C_CFO.CD_CFO,
                      C_CFO.DS_CFO, NULL, V_CDGRUPOFISC, C_CFO.DTINIVALID,
                      'N', NULL, C_CFO.IDINTEREST, SYSDATE);
               END IF;
            END IF;

            V_NRCONTADOR := V_NRCONTADOR + 1;

            IF V_NRCONTADOR = 500 THEN
               V_NRCONTADOR := 0;
               COMMIT;
            END IF;

         END LOOP;
      END IF;
   END LOOP;

   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_PREENCHE_TABELAS_FISCAIS','5.65.XXX'); END;
/
